//
// Michal Drausowski
// ACM 2006 - Problem F
// Program do weryfikacji zadania
//

#include <iostream>
#include <vector>
//#include <conio.h>

using namespace std;

#define RH 2
#define RM 24

typedef unsigned char BYTE;

bool nextkomb(BYTE komb[7], int kombsize, BYTE free[7])
{
	// komb >= 1
	// free <= 5
	int fpos = -1; // indeks pierwszej pozycji w tablicy, ktorej wartosc == 0
	while(free[++fpos] != 0);
	int clean = fpos;
	while((++clean) < 7) free[clean] = 0;

	const int lastapos = kombsize-1;
	int apos = lastapos;
	BYTE cval = komb[apos];
	int i;

	while(true) {
		if( apos < 0 ) return false;
		// i to indeks pierwszej pozycji w tablicy, ktorej wartosc jest wieksza od cval
		i = (free[2] != 0 ) ?
			(
				(free[2] > cval) ?
				((free[1] > cval) ? ((free[0] > cval)?0:1) : 2 )
				:
				((free[3] > cval) ? 3 : ((free[4] > cval)?4:(-1)))
			)
			:
			(
				(free[0] > cval) ? 0 : ((free[1] > cval) ? 1 : -1)
			);

		if( i < 0 ) {
			free[fpos++] = cval;
			free[fpos] = 0;
			cval = komb[--apos];
		}else {
			komb[apos] = free[i];
			free[i] = cval;
			while( apos < lastapos ) {
				komb[++apos] = free[0];
				free[0] = free[1]; free[1] = free[2]; free[2] = free[3];
				free[3] = free[4]; free[4] = free[5];
			}
			return true;
		}
	}
	return false;
}

typedef struct Solution15 {
	BYTE v[15];
	void set(BYTE a0, BYTE a1=0, BYTE a2=0, BYTE a3=0, BYTE a4=0,
		BYTE a5=0, BYTE a6=0, BYTE a7=0, BYTE a8=0, BYTE a9=0,
		BYTE a10=0, BYTE a11=0, BYTE a12=0, BYTE a13=0, BYTE a14=0) {
			v[0] = a0, v[1] = a1, v[2] = a2, v[3] = a3, v[4] = a4;
			v[5] = a5, v[6] = a6, v[7] = a7, v[8] = a8, v[9] = a9;
			v[10] = a10, v[11] = a11, v[12] = a12, v[13] = a13, v[14] = a14; }
}Solution15;


void prepare_tabs(int kombsize, BYTE komb[7], BYTE freechars[7], BYTE orderedchars[7])
{
	int p = 0;
	int f = 0;
	while( p < kombsize )
		komb[p] = orderedchars[p], p++;
	while( p+f < 6 )
		freechars[f] = orderedchars[p+f], f++;
	komb[kombsize] = 0;
	freechars[f] = 0;
}

void makedesc(BYTE desc[20], BYTE m[15], BYTE h[15])
{
	int mi = 0, hi = 0, di = 0;
	while( m[++mi] != 0 ) if( m[mi] != '-' ) desc[di++] = m[mi];
	while( h[++hi] != 0 ) if( h[hi] != '-' ) desc[di++] = h[hi];
	desc[di] = 0;
}

void tsort(BYTE* t, int s)
{
	BYTE b;
	bool re = true;
	while( re ) {
		re = false;
		for(int i=0; i<s-1; i++)
			if( t[i] > t[i+1] ) b = t[i], t[i] = t[i+1], t[i+1] = b, re = true;
	}
}

#define TP(x) (teeth[komb[(x)]])
#define DBCMP(x,y) ((((x)+0.0000001)>(y)) && (((x)-0.0000001)<(y)))
#define GEAR(x) komb[x]

#define C_SHAFTS_REVS_SET(shx, rvx, stx) \
	prepare_tabs(shx, komb, freechars, orderedchars); \
	if( shx <= N ) \
		do{ \
			revs = rvx; \
			if( (revs == RM) || (revs == RH) ){ \
				s.set stx; \
				if( revs == RM ) sM.push_back(s); else sH.push_back(s); \
			} \
		}while( nextkomb(komb, shx, freechars) );


int main()
{
	double teeth[256];
	BYTE komb[7] = {'a', 'b','c','d',0,0,0};
	BYTE freechars[7] = {'e','f',0,0,0,0,0};
	BYTE orderedchars[7] = {'A','B','C','P','Q','R',0};


	int trail = 1;
	int N;
	double R0;

 while(true) {
	cin >> N;
	if( N <= 0 ) return 0;
	cin >> R0;
	for(int i=0; i<7; i++) orderedchars[i] = 0;
	for(int i=0; i<N; i++) {
		cin >> orderedchars[i];
		cin >> teeth[orderedchars[i]];
	}
	tsort(orderedchars, N);

	vector<Solution15> sM, sH;

	//int R0 = 40;
	//teeth['P'] = 7; teeth['Q'] = 84; teeth['R'] = 50; teeth['A'] = 40;
	//teeth['B'] = 30; teeth['C'] = 14;

	double revs;
	Solution15 s;

	//0: *
	revs = R0;
	if( (revs == RM) || (revs == RH) ){
		s.v[0] = '*'; s.v[1] = 0;
		if( revs == RM ) sM.push_back(s); else sH.push_back(s);
	}

	//1: *A-B
	C_SHAFTS_REVS_SET( 2,
		-R0 * (TP(0)/TP(1)),
		('*', GEAR(0), '-', GEAR(1)) );

	//2: *A-B-C
	C_SHAFTS_REVS_SET( 3,
		-(-R0 * (TP(0)/TP(1))) * (TP(1)/TP(2)),
		('*', GEAR(0), '-', GEAR(1), '-', GEAR(2)) );

	//3: *A-BC-D
	C_SHAFTS_REVS_SET( 4,
		-(-R0 * (TP(0)/TP(1))) * (TP(2)/TP(3)),
		('*', GEAR(0), '-', GEAR(1), GEAR(2), '-', GEAR(3)) );

	//4: *A-B-C-D
	C_SHAFTS_REVS_SET( 4,
		-(-(-R0 * (TP(0)/TP(1))) * (TP(1)/TP(2))) * (TP(2)/TP(3)),
		('*', GEAR(0), '-', GEAR(1), '-', GEAR(2), '-', GEAR(3)) );

	//5: *A-BC-D-E
	C_SHAFTS_REVS_SET( 5,
		-(-(-R0 * (TP(0)/TP(1))) * (TP(2)/TP(3))) * (TP(3)/TP(4)),
		('*', GEAR(0), '-', GEAR(1), GEAR(2), '-', GEAR(3), '-', GEAR(4)) );

	//6: *A-B-CD-E
	C_SHAFTS_REVS_SET( 5,
		-(-(-R0 * (TP(0)/TP(1))) * (TP(1)/TP(2))) * (TP(3)/TP(4)),
		('*', GEAR(0), '-', GEAR(1), '-', GEAR(2), GEAR(3), '-', GEAR(4)) );

	//7: *A-BC-DE-F
	C_SHAFTS_REVS_SET( 6,
		-(-(-R0 * (TP(0)/TP(1))) * (TP(2)/TP(3))) * (TP(4)/TP(5)),
		('*', GEAR(0), '-', GEAR(1), GEAR(2), '-', GEAR(3), GEAR(4), '-', GEAR(5)) );

	//8: *A-B-C-D-E
	C_SHAFTS_REVS_SET( 5,
		-(-(-(-R0 * (TP(0)/TP(1))) * (TP(1)/TP(2))) * (TP(2)/TP(3))) * (TP(3)/TP(4)),
		('*', GEAR(0), '-', GEAR(1), '-', GEAR(2), '-', GEAR(3), '-', GEAR(4)) );

	//9: *A-BC-D-E-F
	C_SHAFTS_REVS_SET( 6,
		-(-(-(-R0 * (TP(0)/TP(1))) * (TP(2)/TP(3))) * (TP(3)/TP(4))) * (TP(4)/TP(5)),
		('*', GEAR(0), '-', GEAR(1), GEAR(2), '-', GEAR(3), '-', GEAR(4), '-', GEAR(5)) );

	//10: *A-B-CD-E-F
	C_SHAFTS_REVS_SET( 6,
		-(-(-(-R0 * (TP(0)/TP(1))) * (TP(1)/TP(2))) * (TP(3)/TP(4))) * (TP(4)/TP(5)),
		('*', GEAR(0), '-', GEAR(1), '-', GEAR(2), GEAR(3), '-', GEAR(4), '-', GEAR(5)) );

	//11: *A-B-C-DE-F
	C_SHAFTS_REVS_SET( 6,
		-(-(-(-R0 * (TP(0)/TP(1))) * (TP(1)/TP(2))) * (TP(2)/TP(3))) * (TP(4)/TP(5)),
		('*', GEAR(0), '-', GEAR(1), '-', GEAR(2), '-', GEAR(3), GEAR(4), '-', GEAR(5)) );

	//12: *A-B-C-D-E-F
	C_SHAFTS_REVS_SET( 6,
		-(-(-(-(-R0 * (TP(0)/TP(1))) * (TP(1)/TP(2))) * (TP(2)/TP(3))) * (TP(3)/TP(4))) * (TP(4)/TP(5)),
		('*', GEAR(0), '-', GEAR(1), '-', GEAR(2), '-', GEAR(3), '-', GEAR(4), '-', GEAR(5)) );


	//for(int i=0; i<(int)sM.size(); i++)
	//	cout << i << ", M: " << (sM[i].v) << endl;
	//for(int i=0; i<(int)sH.size(); i++)
	//	cout << i << ", H: " << (sH[i].v) << endl;

	int bestshafts = 99;
	int bestgears = 99;
	BYTE bestdesc[20]; bestdesc[0] = 255; bestdesc[1] = 0;
	BYTE* bestvm = NULL;
	BYTE* bestvh = NULL;

	bool available[256];
	int msize = (int)sM.size();
	int hsize = (int)sH.size();
	for(int m=0; m<msize; m++) {
		for(int h=0; h<hsize; h++) {
			for(int c=0; c<6; c++) available[orderedchars[c]] = true;
			BYTE* vm = sM[m].v;
			BYTE* vh = sH[h].v;
			int mp = 0;
			int hp = 0;
			int shafts = 0;
			int gears = 0;
			while( vm[++mp] == vh[++hp] ) {
				if( vm[mp] == '-') shafts++;
				else available[vm[mp]] = false, gears++;
			}
			while( vm[mp] != 0 ) {
				if( vm[mp] == '-') shafts++;
				else available[vm[mp]] = false, gears++;
				mp++;
			}
			bool bad = false;
			while( vh[hp] != 0 ) {
				if( vh[hp] == '-') {
					if( ++shafts > 5 ) {bad = true; break;}
				}else {
					if( available[vh[hp]] ) {
						if( ++gears > 6 ) {bad = true; break;}
						available[vh[hp]] = false;
					}else {bad = true; break;}
				}
				hp++;
			}
			if( !bad ) {
				bool newsolution = false;
				BYTE newdesc[20];
				if( shafts < bestshafts ) {
					newsolution = true;
				}else
				if( shafts == bestshafts ) {
					if( gears < bestgears ) {
						newsolution = true;
					}else
					if( gears == bestgears ) {
						int bi = 0;
						makedesc(newdesc, vm, vh);
						while( newdesc[bi] == bestdesc[bi] ) bi++;
						if( newdesc[bi] < bestdesc[bi] ) newsolution = true;
					}
				}
				if( newsolution ) {
					bestshafts = shafts;
					bestgears = gears;
					makedesc(bestdesc, vm, vh);
					bestvm = vm;
					bestvh = vh;
				}
			}
		}
	}

	if( trail > 1 ) cout << endl;
	if( bestshafts != 99 ) {
		cout << "Trial " << trail << endl;
		cout << "Minutes: " << bestvm << endl;
		cout << "Hours:   " << bestvh << endl;
	}else {
		cout << "Trial " << trail << " IS IMPOSSIBLE" << endl;
	}
	
	trail++;
 }
	//getch();
	return 0;
}
